<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible" width="1200px">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-row :gutter="20">
        <el-col :span="8">
          <el-form-item :label="t('ProductionPlan.Task.saleDialogCodeLabel')" prop="code">
            <el-input v-model="formData.code" :placeholder="t('ProductionPlan.Task.saleDialogCodePlaceholder')" />
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item :label="t('ProductionPlan.Task.saleDialogDeliveryDateLabel')" prop="deliveryDate">
            <el-date-picker
              v-model="formData.deliveryDate"
              type="date"
              value-format="x"
              :placeholder="t('ProductionPlan.Task.saleDialogDeliveryDatePlaceholder')"
            />
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item :label="t('ProductionPlan.Task.saleDialogRemarkLabel')" prop="remark">
            <el-input v-model="formData.remark" :placeholder="t('ProductionPlan.Task.saleDialogRemarkPlaceholder')" />
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item :label="t('ProductionPlan.Task.saleDialogTaskTypeLabel')" prop="taskType">
        <el-radio-group v-model="formData.taskType">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.MES_TASK_TYPE)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <!-- 子表的表单 -->
    <el-tabs v-model="subTabsName">
      <el-tab-pane :label="t('ProductionPlan.Task.saleDetailTabTaskDetailLabel')" name="taskDetail">
        <TaskAddSaleDetailForm ref="taskDetailFormRef" :task-id="formData.id" />
      </el-tab-pane>
    </el-tabs>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{ t('ProductionPlan.Task.dialogSubmitButtonText') }}</el-button>
      <el-button @click="dialogVisible = false">{{ t('ProductionPlan.Task.dialogCancelButtonText') }}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import {getIntDictOptions, getBoolDictOptions, DICT_TYPE, getStrDictOptions} from '@/utils/dict'
import { TaskApi, TaskVO } from '@/api/mes/task'
import TaskAddSaleDetailForm from './components/TaskAddSaleDetailForm.vue'

/** 生产任务单 表单 */
defineOptions({ name: 'TaskForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  code: undefined,
  orderDate: undefined,
  taskType: undefined,
  deliveryDate: undefined,
  status: undefined,
  processInstanceId: undefined,
  remark: undefined,
  isEnable: undefined,
})
const formRules = reactive({
  code: [{ required: true, message: t('ProductionPlan.Task.saleValidatorCodeRequired'), trigger: 'blur' }],
  deliveryDate: [{ required: true, message: t('ProductionPlan.Task.saleValidatorDeliveryDateRequired'), trigger: 'blur' }],
  taskType: [{ required: true, message: t('ProductionPlan.Task.saleValidatorTaskTypeRequired'), trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 子表的表单 */
const subTabsName = ref('taskDetail')
const taskDetailFormRef = ref()

/** 打开弹窗 */
const open = async (id: number) => {
  const type = "update"
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await TaskApi.getTask(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 校验子表单
  try {
    await taskDetailFormRef.value.validate()
  } catch (e) {
    subTabsName.value = 'taskDetail'
    return
  }
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as TaskVO
    // 拼接子表的数据
    data.taskDetails = taskDetailFormRef.value.getData()
    if (formType.value === 'create') {
      await TaskApi.createTask(data)
      message.success(t('common.createSuccess'))
    } else {
      await TaskApi.updateTask(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    code: undefined,
    orderDate: undefined,
    deliveryDate: undefined,
    status: undefined,
    processInstanceId: undefined,
    remark: undefined,
    isEnable: undefined,
  }
  formRef.value?.resetFields()
}
</script>
